% Test if communities can be described using either approach
N = 14;

resultHGamma = nan(0, 8);
resultXSigma = nan(0, 8);
intermediatePlots = false;

for p2=0:1:ceil(N/2)
    for p1 = 0:p2
        if getP(p2,N,p1) < -p2/2
            continue
        end
        communityMemberTest = @conditionHGamma;
%for p1=0:0.3:1
%    for p2 = 0:30:400
%        communityMemberTest = @conditionXSigma;
%        fprintf('input N=%i p1=%.3f p2=%.3f\n', N,p1,p2);

        c = makeCommunity(N, p1, p2, communityMemberTest);
        fprintf('generate community with %i edges\n\n', nnz(triu(c)));

        [resultHGamma(end+1,:), resultXSigma(end+1,:)] = compareApproachesBody(c,intermediatePlots);
    end
end
titles = {'LL'; 'area'; 'H'; 'gamma'; 'p'; 'theta'; 'x'; 'sigma'};
for q=8:-1:1 
    figure;
    marker = 1;
    if strcmp(titles{q}, 'H') || strcmp(titles{q}, 'gamma')
        marker = 3;
    end
    plot(resultHGamma(:,q), 'LineWidth', marker);
    hold on;
    marker = 1;
    if strcmp(titles{q}, 'x') || strcmp(titles{q}, 'sigma')
        marker = 3;
    end
    plot(resultXSigma(:,q), 'LineWidth', marker);
    title(titles{q});
end;
