function area=getElementsBelowXSigma(N, x, sigma)
% only in upper triangular
% getElementsBelow might be off by 1 due to the floor function and
% floating point arithmetics. If working around this by correcting the
% area if we know that more edges should be inside than the calculated
% area allows. In case this pragmatic approach does not work in some
% particular case, the area can be computed alternatively with
% getAreaOfExpectedCommunity which is much slower but precise.
   cols = 0;
   area = 0;
   for i=0:N
       m = min(N-1,max(0,floor( (sigma - i*x) /  (i - x*(i-1)) )));
       if m <= i
           break;
       else
           area = area + m;
           cols = cols + 1;
       end
   end
   area = area - (cols^2 - cols)/2;
end
