function [ p1, p2,LL ] = recoverCommunityInGraph( c, paramsToFind, graph, coveredByOthers, partialCoverGraph,specialX)
%RECOVERCOMMUNITYINGRAPH returns a model for a community given the adjacency matrix
if ~exist('specialX', 'var')
    specialX = [];
end    
switch paramsToFind
    case 'H,gamma'
        [p1,p2,LL] = recoverHGammaExhaustively(c, graph, coveredByOthers, partialCoverGraph);
    case 'p,theta'
        [H,gamma,LL] = recoverHGammaExhaustively(c, graph, coveredByOthers, partialCoverGraph);
        p1 = getP(gamma, length(c), H);
        p2 = getTheta(gamma, length(c), H);
    case 'x,sigma'
        [p1,p2,LL] = recoverXSigmaExhaustively(c, specialX, graph, coveredByOthers, partialCoverGraph);
    otherwise
        error('Unknown parameters requested');
end

