function [ area ] = testAreaApproxmation( N,H,gamma )

%ATTENTION: H = 1 means 2 edges in the last column!!!
% Gamma = 2 means 3 elements on the diagonal!

N=500;
absError =[];
relError=[];
for gamma=1:249
    for H=1:gamma

%area = getElementsBelow(N,H,gamma);
area = getElementsBelowHGamma(N,H,gamma);
psiAllColumns = getElementsBelowApprox(N,H,gamma);
psiUntilGamma = getElementsBelowApprox3(N,H,gamma);
integralAllColumn = getElementsBelowApprox2(N,H,gamma);
integralGammaToEnd = getElementsBelowApprox4(N,H,gamma);

absError(end+1,:)=[psiAllColumns-area,psiUntilGamma-area,integralAllColumn-area,integralGammaToEnd-area];
relError(end+1,:)=[1-psiAllColumns/area,1-psiUntilGamma/area,1-integralAllColumn/area,1-integralGammaToEnd/area];

    end 
end
end

function area = getElementsBelow(N, H, gamma)
%expected number of 1s inside the community (for upper triangular only)
    N = int32(N);
    H = int32(H);
    gamma = int32(gamma);
    
    area = (H+1)*N-(H+1)-((H+1)*(H+1)-(H+1))/2;

    for i=(H+1):gamma
        % derived from maxIndex = floor(theta/(i+p)-p) for integer division
        gamma2NH = gamma*gamma-(N-1)*H;
        NH2gamma = N-1+H - 2*gamma;
        iNHgamma = i*NH2gamma+gamma2NH;
        maxIndex = idivide( (gamma-H)*(gamma-H)*(gamma-(N-1))*(gamma-(N-1))-gamma2NH*iNHgamma ,...
                            NH2gamma*iNHgamma );
        area = area + maxIndex - i;
    end
    area = double(area);
end

% via PSI function sum over all columns
function area = getElementsBelowApprox(N, H, gamma)
%expected number of 1s inside the community (for upper triangular only)

    gamma2NH = gamma*gamma-(N-1)*H;
     NH2gamma = N-1+H - 2*gamma;
       
     p=gamma2NH/NH2gamma;
     theta=(gamma-H)*(gamma-H)*(gamma-(N-1))*(gamma-(N-1))/(NH2gamma*NH2gamma) ;   

    fullarea = N*(H+1)+theta*(psi(N+p)-psi(H+1+p))-(N-1-H)*(p-1/2);
    %fullarea = N*(H+1)
    %for i=(H+1):(N-1)
    %    fullarea = fullarea + floor(theta/(i+p)-p) + 1
    %end
    
    area = (fullarea-gamma-1)/2;
end

% via PSI function sum only until gamma
function area = getElementsBelowApprox3(N, H, gamma)
%expected number of 1s inside the community (for upper triangular only)

    gamma2NH = gamma*gamma-(N-1)*H;
     NH2gamma = N-1+H - 2*gamma;
       
     p=gamma2NH/NH2gamma;
     theta=(gamma-H)*(gamma-H)*(gamma-(N-1))*(gamma-(N-1))/(NH2gamma*NH2gamma) ;   

    fullarea = N*(H+1)+theta*(psi(gamma+1+p)-psi(H+1+p))-(gamma-H)*(p-1/2);
    %fullarea = N*(H+1)
    %for i=(H+1):(gamma)
    %    fullarea = fullarea + floor(theta/(i+p)-p) + 1
    %end
    
    area = fullarea-((gamma+1)^2+(gamma+1))/2;
end

% via Integral all columns
function area = getElementsBelowApprox2(N, H, gamma)
%expected number of 1s inside the community (for upper triangular only)

    gamma2NH = gamma*gamma-(N-1)*H;
     NH2gamma = N-1+H - 2*gamma;
       
     p=gamma2NH/NH2gamma;
     theta=(gamma-H)*(gamma-H)*(gamma-(N-1))*(gamma-(N-1))/(NH2gamma*NH2gamma) ;   

    fullarea = N*(H+1)+theta*log((N-1+p)/(H+p))-(N-1-H)*(p-1/2);
    %fullarea = N*(H+1)
    %for i=(H+1):(N-1)
    %    fullarea = fullarea + floor(theta/(i+p)-p) + 1
    %end
    
        area = (fullarea-gamma-1)/2;

end

% via Integral only columns from gamma to end 
function area = getElementsBelowApprox4(N, H, gamma)
%expected number of 1s inside the community (for upper triangular only)

    gamma2NH = gamma*gamma-(N-1)*H;
     NH2gamma = N-1+H - 2*gamma;
       
     p=gamma2NH/NH2gamma;
     theta=(gamma-H)*(gamma-H)*(gamma-(N-1))*(gamma-(N-1))/(NH2gamma*NH2gamma) ;   

    fullarea = theta*log((N-1+p)/(gamma+p))-(N-1-gamma)*(p-1/2);
    %fullarea = N*(H+1)
    %for i=(H+1):(N-1)
    %    fullarea = fullarea + floor(theta/(i+p)-p) + 1
    %end
    
        area = fullarea+((gamma+1)^2-(gamma+1))/2;

end