% extends communities from the core
minsize = 100; 
maxsize = 1000; 
if ~exist('communities', 'var')
    try load(['../data/youtube_' int2str(minsize) '_' int2str(maxsize) '.mat']);
    catch
        dataset = '../data/com-youtube.ungraph.txt';
        communityInfo = '../data/com-youtube.all.cmty.txt';
        skiplines = 4;
        [communities, graph, commVec] = readCommunities(...
            dataset, communityInfo, skiplines, minsize, maxsize);
        % small ones first
        [order,indices] = sort(cellfun('length', commVec), 'ascend');
        communities=communities(indices);
        commVec = commVec(indices);
        save(['../data/youtube_' int2str(minsize) '_' int2str(maxsize) '.mat'],...
            'graph', 'commVec', 'communities');
    end
end
results = cell(length(communities),6);
results2 = cell(length(communities),6);
for k=[30,31,40,69,72,91,103,110]%1:length(communities)
    fprintf('Community %i:\n', k);
    [c,indexOrder]=degree_ord(communities{k}); 
    
    fprintf('isolated ');
    [ comm, LL, p1, p2 ] = growCommunity(1:3,c,'H,gamma');
    results(k,:) = { comm, LL, p1, p2, jaccard(comm,1:length(c)), containment(comm,1:length(c)) };

    ci = commVec{k}(indexOrder);
    fprintf('in graph ');
    [ comm2, LL2, p12, p22 ] = growCommunity(ci(1:3),graph,'H,gamma', length(ci));
    results2(k,:) = { comm2, LL2, p12, p22, jaccard(comm2,ci), containment(comm2,ci)};    
end
